exec( "./support.cs" );

$ZHUD::ShowHelmet = true;

if ( !isFile( "base/client/ui/cache/pirulen_25.gft" ) )
{
	fileCopy( "Add-Ons/System_ZeigHUD/pirulen_25.gft", "base/client/ui/cache/pirulen_25.gft" );
}

function zhud_helmet( %bool )
{
	$ZHUD::ShowHelmet = ( %bool );
	zeigHUD.update();
}

function zhud_set_color( %color, %r, %g, %b, %a )
{
	if ( !strLen( %a ) )
	{
		%a = 160;
	}

	zeigHUD.hc_[ %color ] = %r SPC %g SPC %b SPC %a;
	zeigHUD.update();
}

if ( !isObject( "zeigHUD" ) )
{
	new guiSwatchCtrl( "zeigHUD" )
	{
		position = "0 0";
		extent = "0 0";
		minExtent = "0 0";
		visible = false;

		hc_default = "165 228 250 160";
		hc_disabled = "165 228 250 80";
		hc_defdark = "83 114 125 60";
		hc_background = "0 0 0 128";
		hc_panic = "255 160 0 160";
		hc_terror = "255 0 0 160";

		// Elements.
		new guiSwatchCtrl( "zh_healthMeter" )
		{
			position = "0 0";
			extent = "0 0";
			minExtent = "0 0";
			visible = false;
			color = "0 0 0 0";

			ui = 0;
			mod = 0;
			disabled_mod = 0;

			new guiMLTextCtrl( "zh_hm_text" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				text = "";
			};

			new guiSwatchCtrl( "zh_hm_bar" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				color = "0 0 0 0";
			};

			new guiSwatchCtrl( "zh_hm_brc" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				color = "0 0 0 0";
			};

			new guiSwatchCtrl( "zh_hm_brl" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				color = "0 0 0 0";
			};
		};

		new guiSwatchCtrl( "zh_ammoMeter" )
		{
			position = "0 0";
			extent = "0 0";
			minExtent = "0 0";
			visible = false;
			color = "0 0 0 0";

			ui1 = 0;
			ui2 = 0;
			mod = 0;

			new guiMLTextCtrl( "zh_am_text1" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				text = "";
			};

			new guiMLTextCtrl( "zh_am_text2" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				text = "";
			};

			new guiSwatchCtrl( "zh_am_sep" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				color = "0 0 0 0";
			};

			new guiSwatchCtrl( "zh_am_bar" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				color = "0 0 0 0";
			};

			new guiSwatchCtrl( "zh_am_brc" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				color = "0 0 0 0";
			};

			new guiSwatchCtrl( "zh_am_brl" )
			{
				position = "0 0";
				extent = "0 0";
				minExtent = "0 0";
				visible = true;
				color = "0 0 0 0";
			};
		};

		// Helmet Overlay.
		new guiBitmapCtrl( "zh_hudTop" )
		{
			position = "0 0";
			extent = "0 0";
			minExtent = "0 0";
			visible = false;
			color = "0 0 0 0";
			bitmap = "./hudtop.png";
		};

		new guiBitmapCtrl( "zh_hudBottom" )
		{
			position = "0 0";
			extent = "0 0";
			minExtent = "0 0";
			visible = false;
			color = "0 0 0 0";
			bitmap = "./hudbottom.png";
		};
	};
}

package zeigHUD_client
{
	function disconnect()
	{
		clientCmdZHUD_SetState( false );
		parent::disconnect();
	}

	function toggleFirstPerson( %val )
	{
		parent::toggleFirstPerson( %val );
		zeigHUD.update();
	}

	function handleYourDeath( %x, %y, %z )
	{
		parent::handleYourDeath( %x, %y, %z );
		zeigHUD.update();
	}

	function playGUI::onSleep( %this )
	{
		clientCmdZHUD_SetState( false );
		parent::onSleep( %this );
	}
};

activatePackage( "zeigHUD_client" );

function clientCmdZHUD_SetState( %bool )
{
	zeigHUD.reset();

	if ( !isObject( canvas.getContent() ) || canvas.getContent().getName() !$= "playGUI" )
	{
		%bool = false;
	}

	clientCmdZHUD_SetType( 0 );
	clientCmdZHUD_UpdateHealth( false, 0, 0 );
	clientCmdZHUD_UpdateAmmo( false, 0, 0, 0 );
	zeigHUD.setVisible( %bool );

	if ( %bool )
	{
		playGUI.add( zeigHUD );
		playGUI.bringToFront( zeigHUD );
		zeigHUD.update();
	}
	else if ( playGUI.isMember( zeigHUD ) )
	{
		playGUI.remove( zeigHUD );
	}
}

function clientCmdZHUD_SetType( %int )
{
	if ( %int == 0 )
	{
		zh_hudTop.setBitmap( "Add-Ons/System_ZeigHUD/hudtop" );
		zh_hudBottom.setBitmap( "Add-Ons/System_ZeigHUD/hudbottom" );

		zhud_set_color( "default", 165, 228, 250 );
		zhud_set_color( "disabled", 165, 228, 250, 80 );
		zhud_set_color( "defdark", 83, 114, 125, 60 );
		zhud_set_color( "background", 0, 0, 0, 128 );
		zhud_set_color( "panic", 255, 160, 0 );
		zhud_set_color( "terror", 255, 0, 0 );
	}
	else if ( %int == 1 )
	{
		zh_hudTop.setBitmap( "Add-Ons/System_ZeigHUD/hudtop_alt" );
		zh_hudBottom.setBitmap( "Add-Ons/System_ZeigHUD/hudbottom_alt" );

		zhud_set_color( "default", 120, 200, 80 );
		zhud_set_color( "disabled", 165, 228, 250, 80 );
		zhud_set_color( "defdark", 83, 114, 125, 60 );
		zhud_set_color( "background", 0, 0, 0, 128 );
		zhud_set_color( "panic", 255, 100, 0 );
		zhud_set_color( "terror", 0, 160, 255 );
	}
}

function clientCmdZHUD_UpdateHealth( %bool, %ui, %mod, %ndf )
{
	%ui = mFloatLength( %ui, 0 );

	if ( %ui < 0 )
	{
		%ui = 0;
	}

	if ( %ui > 999 )
	{
		%ui = 999;
	}

	if ( %mod < 0 )
	{
		%mod = 0;
	}

	if ( %mod > 1 )
	{
		%mod = 1;
	}

	if ( !%ndf && zh_healthMeter.mod > %mod )
	{
		%sub = zh_healthMeter.mod - %mod;
		zh_healthMeter.doPainFade( %sub / 1 );
	}
	else if ( zh_healthMeter.mod < %mod )
	{
		zh_healthMeter.lastDamage = 0;
		zh_healthMeter.lastDamageTime = 0;
		zh_healthMeter.update();

		cancel( zeigHUD.updateLooper );
	}

	zh_healthMeter.ui = %ui;
	zh_healthMeter.mod = %mod;

	if ( zh_healthMeter.disabled_mod < %mod )
	{
		zh_healthMeter.disabled_mod = %mod;
	}
	else if ( zh_healthMeter.disabled_mod > %mod && !isEventPending( zh_healthMeter.dc_dh_br ) )
	{
		zh_healthMeter.dc_dh_br = zh_healthMeter.schedule( 16, "dc_dh_br" );
	}

	zh_healthMeter.setVisible( %bool );
	zh_healthMeter.update();
}

function clientCmdZHUD_UpdateAmmo( %bool, %ui1, %ui2, %mod )
{
	%ui1 = mFloatLength( %ui1, 0 );
	%ui2 = mFloatLength( %ui2, 0 );

	if ( %ui1 < 0 )
	{
		%ui1 = 0;
	}

	if ( %ui1 > 999 )
	{
		%ui1 = 999;
	}

	if ( %mod < 0 )
	{
		%mod = 0;
	}

	if ( %mod > 1 )
	{
		%mod = 1;
	}

	zh_ammoMeter.ui1 = %ui1;
	zh_ammoMeter.ui2 = %ui2;
	zh_ammoMeter.mod = %mod;

	if ( zh_ammoMeter.disabled_mod < %mod )
	{
		zh_ammoMeter.disabled_mod = %mod;
	}
	else if ( zh_ammoMeter.disabled_mod > %mod )
	{
		zh_ammoMeter.dc_da_br = zh_ammoMeter.schedule( 16, "dc_da_br" );
	}

	zh_ammoMeter.setVisible( %bool );
	zh_ammoMeter.update();
}

function zeigHUD::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%this.position = "0 0";
	%this.extent = %res;

	%cnt = %this.getCount();

	for ( %i = 0 ; %i < %cnt ; %i++ )
	{
		%obj = %this.getObject( %i );

		if ( %obj.hasMethod( "update" ) )
		{
			%obj.call( "update", %res );
		}
	}
}

function zeigHUD::reset( %this )
{
	%cnt = %this.getCount();

	for ( %i = 0 ; %i < %cnt ; %i++ )
	{
		%obj = %this.getObject( %i );

		if ( %obj.hasMethod( "reset" ) )
		{
			%obj.call( "reset" );
		}
	}
}

function zeigHUD::updateLooper( %this, %target )
{
	cancel( %this.updateLooper );

	%this.update();

	if ( getSimTime() >= %target )
	{
		return;
	}

	%this.updateLooper = %this.schedule( 16, "updateLooper", %target );
}

function zh_healthMeter::dc_dh_br( %this )
{
	cancel( %this.dc_dh_br );

	if ( %this.disabled_mod <= %this.mod )
	{
		%this.disabled_mod = %this.mod;
		%this.update();

		return;
	}

	%dec = 0.02 * ( %this.disabled_mod - %this.mod );

	if ( %dec < 0.005 )
	{
		%dec = 0.005;
	}

	if ( %this.disabled_mod - %dec <= %this.mod )
	{
		%this.disabled_mod = %this.mod;
	}
	else
	{
		%this.disabled_mod -= %dec;
	}

	%this.update();
	%this.dc_dh_br = %this.schedule( 16, "dc_dh_br" );
}

function zh_ammoMeter::dc_da_br( %this )
{
	cancel( %this.dc_da_br );

	if ( %this.disabled_mod <= %this.mod )
	{
		%this.disabled_mod = %this.mod;
		%this.update();

		return;
	}

	if ( %this.disabled_mod - 0.01 <= %this.mod )
	{
		%this.disabled_mod = %this.mod;
	}
	else
	{
		%this.disabled_mod -= 0.01;
	}

	%this.update();
	%this.dc_da_br = %this.schedule( 16, "dc_da_br" );
}

function zh_hudTop::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%width = getWord( %res, 0 );

	if ( %width >= 1318 )
	{
		%this.position = mFloor( ( %width - 1318 ) / 2 ) SPC -28;
		%this.extent = "1318 128";
	}
	else
	{
		%this.position = 0 SPC mFloor( ( %width / 1318 )  * -28 );
		%this.extent = %width SPC mFloor( ( %width / 1318 ) * 128 );
	}

	%visible = false;

	if ( isObject( %sc = serverConnection ) && isObject( %co = %sc.getControlObject() ) && isObject( %db = %co.getDataBlock() ) )
	{
		%visible = ( ( %co.getClassName() $= "Player" || %co.getClassName() $= "AIPlayer" ) && ( !%db.thirdPersonOnly && $firstPerson ) );
	}

	if ( !$ZHUD::ShowHelmet )
	{
		%visible = false;
	}

	%this.setVisible( %visible );

	%cnt = %this.getCount();

	for ( %i = 0 ; %i < %cnt ; %i++ )
	{
		%obj = %this.getObject( %i );

		if ( %obj.hasMethod( "update" ) )
		{
			%obj.call( "update", %res );
		}
	}
}

function zh_hudBottom::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%width = getWord( %res, 0 );
	%height = getWord( %res, 1 );

	if ( %width >= 1024 )
	{
		%this.position = mFloor( ( %width - 1024 ) / 2 ) SPC %height - 128;
		%this.extent = "1024 128";
	}
	else
	{
		%this.position = 0 SPC %height - mFloor( ( %width / 1024 )  * 128 );
		%this.extent = %width SPC mFloor( ( %width / 1024 ) * 128 );
	}

	%visible = false;

	if ( isObject( %sc = serverConnection ) && isObject( %co = %sc.getControlObject() ) && isObject( %db = %co.getDataBlock() ) )
	{
		%visible = ( ( %co.getClassName() $= "Player" || %co.getClassName() $= "AIPlayer" ) && ( !%db.thirdPersonOnly && $firstPerson ) );
	}

	if ( !$ZHUD::ShowHelmet )
	{
		%visible = false;
	}

	%this.setVisible( %visible );

	%cnt = %this.getCount();

	for ( %i = 0 ; %i < %cnt ; %i++ )
	{
		%obj = %this.getObject( %i );

		if ( %obj.hasMethod( "update" ) )
		{
			%obj.call( "update", %res );
		}
	}
}

function zh_healthMeter::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%cnt = %this.getCount();

	for ( %i = 0 ; %i < %cnt ; %i++ )
	{
		%obj = %this.getObject( %i );

		if ( %obj.hasMethod( "update" ) )
		{
			%obj.call( "update", %res );
		}
	}

	%width = getWord( %res, 0 );
	%value = mFloor( %width / 3 );

	%this.position = mFloor( %value ) SPC mFloor( ( %width / 1318 > 1 ? 1 : %width / 1318 ) * 128 );
	%this.extent = %value SPC 25;
}

function zh_healthMeter::reset( %this )
{
	%this.lastDamage = 0;
	%this.lastDamageTime = 0;
}

function zh_healthMeter::doPainFade( %this, %mod )
{
	%time = mFloor( 10000 * %mod );
	%sim = getSimTime();

	%this.lastDamage = %sim;
	%this.lastDamageTime = %time;

	zeigHUD.updateLooper( %sim + %time );
}

function zh_hm_text::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%color = colorGradient( zh_healthMeter.mod, zeigHUD.hc_panic, zeigHUD.hc_default );
	%lastd = getSimTime() - zh_healthMeter.lastDamage;

	if ( %lastd >= 0 && %lastd < zh_healthMeter.lastDamageTime )
	{
		%color = colorGradient( %lastd / zh_healthMeter.lastDamageTime, zeigHUD.hc_terror, %color );
	}

	%color = rgbToHex( %color );

	%this.position = "0 0";
	%this.extent = "60 25";
	%this.setText( "<just:right><color:" @ %color @ "><font:pirulen:25>" @ zh_healthMeter.ui );
}

function zh_hm_bar::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%this.position = "63 13";
	%this.extent = mFloor( getWord( %res, 0 ) / 3 ) - 63 SPC 8;
	%this.color = zeigHUD.hc_defdark;
}

function zh_hm_brc::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%color = colorGradient( zh_healthMeter.mod, zeigHUD.hc_panic, zeigHUD.hc_default );
	%lastd = getSimTime() - zh_healthMeter.lastDamage;

	if ( %lastd >= 0 && %lastd < zh_healthMeter.lastDamageTime )
	{
		%color = colorGradient( %lastd / zh_healthMeter.lastDamageTime, zeigHUD.hc_terror, %color );
	}

	%this.position = "63 13";
	%this.extent = mFloor( ( getWord( %res, 0 ) / 3 - 63 ) * zh_healthMeter.mod ) SPC 8;
	%this.color = %color SPC 160;
}

function zh_hm_brl::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%space = mFloor( getWord( %res, 0 ) / 3 - 63 );

	%this.position = 63 + mFloor( %space * zh_healthMeter.mod ) SPC 13;
	%this.extent = mFloor( %space * ( zh_healthMeter.disabled_mod - zh_healthMeter.mod ) ) SPC 8;
	%this.color = zeigHUD.hc_disabled;
}

function zh_ammoMeter::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%cnt = %this.getCount();

	for ( %i = 0 ; %i < %cnt ; %i++ )
	{
		%obj = %this.getObject( %i );

		if ( %obj.hasMethod( "update" ) )
		{
			%obj.call( "update", %res );
		}
	}

	%width = getWord( %res, 0 );

	%this.position = %width - mFloor( ( %width / 1318 > 1 ? 1 : %width / 1318 ) * 128 ) - 71 SPC mFloor( getWord( %res, 1 ) / 3 );
	%this.extent = 71 SPC mFloor( getWord( %res, 1 ) / 2 );
}

function zh_am_text1::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%color = rgbToHex( zeigHUD.hc_default );

	%this.position = "0 0";
	%this.extent = "60 25";
	%this.setText( "<just:center><color:" @ %color @ "><font:pirulen:25>" @ zh_ammoMeter.ui1 );
}

function zh_am_text2::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%color = rgbToHex( zeigHUD.hc_default );

	%this.position = "0 29";
	%this.extent = "60 25";
	%this.setText( "<just:center><color:" @ %color @ "><font:pirulen:25>" @ zh_ammoMeter.ui2 );
}

function zh_am_sep::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%this.position = "0 27";
	%this.extent = "60 2";
	%this.color = zeigHUD.hc_default;
}

function zh_am_bar::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%this.position = "63 0";
	%this.extent = 8 SPC mFloor( getWord( %res, 1 ) / 2 );
	%this.color = zeigHUD.hc_defdark;
}

function zh_am_brc::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%space = mFloor( getWord( %res, 1 ) / 2 );
	%height = mFloor( %space * zh_ammoMeter.mod );

	%this.position = 63 SPC %space - %height;
	%this.extent = 8 SPC %height;
	%this.color = zeigHUD.hc_default;
}

function zh_am_brl::update( %this, %res )
{
	if ( !strLen( %res ) )
	{
		%res = getWords( getRes(), 0, 1 );
	}

	%space = mFloor( getWord( %res, 1 ) / 2 );
	%rmdsh = mFloor( %space * zh_ammoMeter.mod );
	%dmdsh = mFloor( %space * ( zh_ammoMeter.disabled_mod - zh_ammoMeter.mod ) );

	%this.position = 63 SPC %space - %rmdsh - %dmdsh;
	%this.extent = 8 SPC %dmdsh;
	%this.color = zeigHUD.hc_default;
}