exec( "./support.cs" );

package zeigHUD_server
{
	function gameConnection::spawnPlayer( %this )
	{
		parent::spawnPlayer( %this );

		if ( isObject( %pl = %this.player ) )
		{
			%this.schedule( 100, "setZeigHUD", true, true );
		}
	}

	function gameConnection::onDeath( %this, %a, %b, %c, %d, %e, %f, %g, %h, %i )
	{
		parent::onDeath( %this, %a, %b, %c, %d, %e, %f, %g, %h, %i );
		%this.setZeigHUD( false );
	}

	function armor::onAdd( %this, %obj )
	{
		if ( %this.hasMethod( "onAdd" ) )
		{
			parent::onAdd( %this, %obj );
		}

		%obj.updateZeigHUD( true );
	}

	function armor::onNewDataBlock( %this, %obj )
	{
		if ( %this.hasMethod( "onNewDataBlock" ) )
		{
			parent::onNewDataBlock( %this, %obj );
		}

		%obj.schedule( 50, "updateZeigHUD", true );
	}

	function player::damage( %this, %a, %b, %c, %d, %e, %f, %g, %h, %i )
	{
		parent::damage( %this, %a, %b, %c, %d, %e, %f, %g, %h, %i );
		%this.updateZeigHUD( true );
	}

	function player::addHealth( %this, %val )
	{
		parent::addHealth( %this, %val );
		%this.updateZeigHUD();
	}

	function gameConnection::onClientEnterGame( %this )
	{
		parent::onClientEnterGame( %this );
		%this.schedule( 100, "setZeigHUD", true, true );
	}

	function gameConnection::onClientLeaveGame( %this )
	{
		%this.setZeigHUD( false );
		parent::onClientLeaveGame( %this );
	}

	function serverCmdUseTool( %cl, %inv )
	{
		parent::serverCmdUseTool( %cl, %inv );
		%cl.updateZeigHUD();
	}

	function serverCmdUnUseTool( %cl )
	{
		parent::serverCmdUnUseTool( %cl );
		%cl.updateZeigHUD();
	}

	function armor::onTrigger( %this, %obj, %slot, %val )
	{
		parent::onTrigger( %this, %obj, %slot, %val );

		if ( isObject( %cl = %obj.client ) )
		{
			if ( %val )
			{
				%cl.updateZeigHUDLoop();
			}
			else
			{
				cancel( %cl.updateZeigHUDLoop );
			}
		}
	}

	function player::playThread( %this, %a, %b )
	{
		parent::playThread( %this, %a, %b );
		%this.updateZeigHUD();
		%this.schedule( 400, "updateZeigHUD" );
		%this.schedule( 800, "updateZeigHUD" );
	}
};

activatePackage( "zeigHUD_server" );

function gameConnection::setZeigHUD( %this, %bool, %ndf )
{
	commandToClient( %this, 'ZHUD_SetState', %bool );

	if ( %bool )
	{
		%this.updateZeigHUD( %ndf );
	}
	else
	{
		cancel( %this.updateZeigHUDLoop );
	}
}

function player::setZeigHUD( %this, %bool )
{
	if ( isObject( %cl = %this.client ) )
	{
		%cl.setZeigHUD( %bool );
	}
}

function gameConnection::updateZeigHUDLoop( %this )
{
	cancel( %this.updateZeigHUDLoop );
	%this.updateZeigHUD();
	%this.updateZeigHUDLoop = %this.schedule( 100, "updateZeigHUDLoop" );
}

function gameConnection::updateZeigHUD( %this, %ndf )
{
	if ( !isObject( %pl = %this.player ) )
	{
		return;
	}
	
	%dmg = %pl.getDamageLevel();
	%max = %pl.getDataBlock().maxDamage;
	
	commandToClient( %this, 'ZHUD_UpdateHealth', true, mCeil( %max - %dmg ), 1 - ( %dmg / %max ), %ndf );

	if ( isObject( %mn = %pl.getMountedImage( 0 ) ) && %mn.item.maxAmmo > 0 )
	{
		%load = %pl.toolAmmo[ %pl.currTool ];
		%mlod = %mn.item.maxAmmo;
		%mod = %load / %mlod;

		commandToClient( %this, 'ZHUD_UpdateAmmo', true, %load, %mlod, %mod );
	}
	else
	{
		commandToClient( %this, 'ZHUD_UpdateAmmo', false, 0, 0, 0 );
	}
}

function Player::updateZeigHUD( %this, %ndf )
{
	if ( isObject( %cl = %this.client ) )
	{
		%cl.updateZeigHUD( %ndf );
	}
}